#include "X3D_DFSGraphTraversal.h"
#include "X3D_DFSCoreWalker.h"
#include "X3D_DFSGeometry3DWalker.h"
#include "X3D_DFSGroupingWalker.h"
#include "X3D_DFSRenderingWalker.h"
#include "X3D_DFSShapeWalker.h"
#include "X3D_DFSTexturingWalker.h"
#include "X3D_DFSInterpolationWalker.h"
#include "X3D_DFSLightingWalker.h"
#include "X3D_DFSNURBSWalker.h"
#include "X3D_DFSNetworkingWalker.h"

namespace X3DTK {
namespace X3D {

DFSGraphTraversal::DFSGraphTraversal()
: GraphTraversal()
{
  setComponentWalker(new DFSCoreWalker());
  setComponentWalker(new DFSGeometry3DWalker());
  setComponentWalker(new DFSGroupingWalker());
  setComponentWalker(new DFSRenderingWalker());
  setComponentWalker(new DFSShapeWalker());
  setComponentWalker(new DFSTexturingWalker());
  setComponentWalker(new DFSInterpolationWalker());
  setComponentWalker(new DFSLightingWalker());
  setComponentWalker(new DFSNURBSWalker());
  setComponentWalker(new DFSNetworkingWalker());
}

DFSGraphTraversal::~DFSGraphTraversal()
{
}

void DFSGraphTraversal::setComponentWalker(X3DComponentWalker *component)
{
  GraphTraversal::setComponentWalker(component);
}

}
}
