#include "X3D_InlineLoader.h"
#include "X3D_DFSGraphTraversal.h"
#include "X3D_InlineLoaderCoreVisitor.h"
#include "X3D_InlineLoaderNetworkingVisitor.h"

namespace X3DTK {
namespace X3D {

InlineLoader::InlineLoader()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<InlineLoaderStateVariables>();
  graphTraversal = new DFSGraphTraversal();
  
  graphTraversal->setComponentVisitor(new InlineLoaderCoreVisitor());
  graphTraversal->setComponentVisitor(new InlineLoaderNetworkingVisitor());
}

InlineLoader::~InlineLoader()
{
  GraphTraversal::removeInstanceOf<InlineLoaderStateVariables>();
  
  delete graphTraversal;
}

void InlineLoader::load(SFNode N, bool force)
{
  stateVariables->setForce(force);
  
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
  
  while (stateVariables->hasInline())
  {
    stateVariables->init();
    graphTraversal->traverse(N);
    stateVariables->finish();
  }
}

}
}
