#include "X3D_WorldCoordTranslatorGroupingVisitor.h"
#include "X3D_Group.h"
#include "X3D_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

WorldCoordTranslatorGroupingVisitor::WorldCoordTranslatorGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineEnterFunction(&WorldCoordTranslatorGroupingVisitor::enterTransform);
  
  // Leave functions.
  defineLeaveFunction(&WorldCoordTranslatorGroupingVisitor::leaveTransform);
  
  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<WorldCoordTranslatorStateVariables>();
}

WorldCoordTranslatorGroupingVisitor::~WorldCoordTranslatorGroupingVisitor()
{
}

void WorldCoordTranslatorGroupingVisitor::enterTransform(Transform *T) const
{
  SFMatrix34f transform(T->getTranslation(), T->getCenter(), T->getRotation(), T->getScaleOrientation(), T->getScale());
  
  T->setCenter(SFVec3f(0.0f, 0.0f, 0.0f));
  T->setRotation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f));
  T->setScale(SFVec3f(1.0f, 1.0f, 1.0f));
  T->setScaleOrientation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f));
  T->setTranslation(SFVec3f(0.0f, 0.0f, 0.0f));
  
  stateVariables->pushMatrix(transform);
}

void WorldCoordTranslatorGroupingVisitor::leaveTransform(Transform *) const
{
  stateVariables->popMatrix();
}

}
}
