#include "X3D_WorldCoordTranslatorStateVariables.h"

#include <algorithm>

using namespace std;

namespace X3DTK {
namespace X3D {

WorldCoordTranslatorStateVariables::WorldCoordTranslatorStateVariables()
: StateVariables()
{
}

WorldCoordTranslatorStateVariables::~WorldCoordTranslatorStateVariables()
{
}

void WorldCoordTranslatorStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void WorldCoordTranslatorStateVariables::finish()
{
  _matrixStack.clear();
  _nodeList.clear();
}

void WorldCoordTranslatorStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void WorldCoordTranslatorStateVariables::pushNode(SFNode N)
{
  _nodeList.push_back(N);
}

void WorldCoordTranslatorStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

bool WorldCoordTranslatorStateVariables::findNode(SFNode N)
{
  list<SFNode>::iterator it = find(_nodeList.begin(), _nodeList.end(), N);
  return (it != _nodeList.end());
}

}
}
